Subject: RE: FCIP/iFCP : Guarantee In-Order delivery for FC N/NL_ports

From: Joshua Tseng <[email-masked]>
Date: Thu, 18 Jan 2001 15:19:38 -0800

> 
> I have a question for the FCIP and iFCP folks. Do these 2 
> protocols still 
> assure in-order delivery of frames to the FC end nodes (N/NL_Ports) 
> when requested through the "Sequential Delivery" bit in FLOGI ?

TCP will deliver the FC frames in the same order that they were
passed to TCP by the FC network (FCIP or iFCP) or FC device (iFCP only).
As long as the FC network or device passes them in the right order,
TCP will do its part to keep the frames in the same order.

> 
> Can this assurance be made even while using multiple TCP 
> connections b/n 
> edge switch/routers ? 

This question is N/A for FCIP, since only a single connection
is specified between FCIP gateways.  In iFCP, a single TCP connection
is specified between each unique pair of N_PORTs.  Each gateway may
support multiple N_PORTs, but this will not interfere with frame
delivery order between each N_PORT pair.  So the answer to your
question is yes for iFCP.

Josh

> 
> - Santosh
> 
> -- 
> #################################
> Santosh Rao
> Software Design Engineer,
> HP, Cupertino.
> email : [email-masked]
> Phone : 408-447-3751
> #################################
>

---

From: Santosh Rao <[email-masked]>
Date: Thu, 18 Jan 2001 18:18:34 -0800

Sriram Rupanagunta wrote:

> Sometime back, FCIP folks mentioned that there is nothing in the
> FCIP spec that limits the number of connections to one. My
> understanding is FCIP leaves this to implementations, whether
> to use one connection or multiple.

The above is EXACTLY the reason I have raised this question. I hear
conflicting statements being made on this issue. I don't see how FCIP can
use multiple TCP connections per (S_ID, D_ID) pair and guarantee in-order
delivery without implementing buffering and re-ordering on the FC-IP
switch.

Both FCIP and iFCP MUST guarantee in-order delivery since all FC end ports
(N/NL_Ports) depend on this feature and FC-FLA Table 3 mandates this.

Regards,
Santosh

>
> Can someone clarify this once for all on this list please ?
>
> If there is no limit on the number of connections in FCIP,
> Santosh's question is valid. In that case, is it fair to
> say that FCIP does not guarentee orderly delivery ?
>
> - Sriram

---

From: "Sriram Rupanagunta" <[email-masked]>
Date: Thu, 18 Jan 2001 19:46:00 -0600

- Sriram